
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


#define MAX 30000  /* usa 10000000 (333 vezes maior) se comentares o Bubble sort */

int v1[MAX], v2[MAX];


void troca( int v[], int i, int j )
{
	int tmp;

	tmp = v[i];
	v[i] = v[j];
	v[j] = tmp;
}


void quicksort( int v[], int begin, int end )
{
	int pivot, l, r;

	pivot = v[ (begin+end) / 2 ];
	l = begin;
	r = end;

	for(;;)	{
		while( v[l] < pivot )
			l++;
		while( pivot < v[r] )
			r--;
		if( r <= l )
			break;
		troca( v, l, r );
		l++;
		r--;
		}
	/* aqui, l==r */

	if( begin < --l )  /* se existem elementos 'a esquerda do pivot... */
		quicksort( v, begin, l   );
	if( ++r   < end )  /* se existem elementos 'a direita do pivot... */
		quicksort( v, r,     end );
}


void shellsort( int v[], int size )
{
	int i, j, incr, temp;
	incr = size / 2;

	while( incr > 0 )
		{
		for( i = incr;  i < size;  i++ )
			{
			temp = v[i];
			j = i;
			while( j >= incr  &&  v[j-incr] > temp )
				{
				v[j] = v[j - incr];
				j -= incr;
				}
			v[j] = temp;
			}

		if( incr == 2 )
			incr = 1;
		else
			incr /= 2.2;
		}
}


void bubblesort( int v[], int tam )
{
	int i, j, t;

	for(i=0; i<tam-1; i++)
		{
		for(j=0; j<tam-1-i; j++)
			{
			if(v[j] > v[j+1])
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


/* Devolve true (1) se a ordenacao foi bem feita */
int confirmar( int v[], int tam )
{
	int i;

	for( i = 1;  i < tam;  i++ )
		if( v[i-1] > v[i] )
			return 0;
	return 1;
}


int main()
{
	int i;
	time_t t_inicial, t_final;

	puts( "A preencher o vector...\n" );
	for( i = 0;  i < MAX;  i++ )
		v1[i] = rand();

	puts( "A testar o Quick sort..." );
	memcpy( v2, v1, sizeof(v1) );
	t_inicial = time( NULL );
	quicksort( v2, 0, MAX-1 );
	t_final = time( NULL );
	if( !confirmar(v2, MAX) )
		puts( "Ordenacao incorrecta!" );
	printf( "\tTempo demorado: %ds\n\n", (int) t_final-t_inicial+1 );

	puts( "A testar o Shell sort..." );
	memcpy( v2, v1, sizeof(v1) );
	t_inicial = time( NULL );
	shellsort( v2, MAX );
	t_final = time( NULL );
	if( !confirmar(v2, MAX) )
		puts( "Ordenacao incorrecta!" );
	printf( "\tTempo demorado: %ds\n\n", (int) t_final-t_inicial+1 );

	puts( "A testar o Bubble sort..." );
	memcpy( v2, v1, sizeof(v1) );
	t_inicial = time( NULL );
	bubblesort( v2, MAX );
	t_final = time( NULL );
	if( !confirmar(v2, MAX) )
		puts( "Ordenacao incorrecta!" );
	printf( "\tTempo demorado: %ds\n\n", (int) t_final-t_inicial+1 );

	return 0;
}

