#include <stdio.h>
#include <stdlib.h>

struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void insere_cabeca( elemento **p_primeiro, int valor )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = valor;
	p->proximo = *p_primeiro;
	*p_primeiro = p;
}


void insere_cauda( elemento **p_primeiro, int valor )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = valor;
	p->proximo = NULL;
	if( primeiro == NULL )
		*p_primeiro = p;
	else
		{
		for( ultimo = *p_primeiro;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
}


void remove_cabeca( elemento **p_primeiro )
{
	elemento *temp, *primeiro = *p_primeiro;

	/* Elimina a cabeca */
	if( primeiro != NULL )
		{
		temp = primeiro;
		*p_primeiro = primeiro->proximo;
		free( temp );
		}
}


void remove_cauda( elemento **p_primeiro )
{
	elemento *p, *primeiro = *p_primeiro;

	/* Elimina a cauda */
	if( primeiro != NULL )
		{
		if( primeiro->proximo != NULL )
			{
			for( p = primeiro;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( primeiro );
			*p_primeiro = NULL;
			}
		}
}


elemento *pesquisa( elemento *primeiro, int valor )
{
	elemento *p;
	for( p = primeiro; p != NULL; p = p->proximo )
		{
		if( p->valor == valor )
			break;
		}
	return p;
}


int main( void )
{
	int menu, valor;
	elemento *elem;

	do	{
		printf(	"\n"
			"Escolha uma opcao\n"
			"1 - Insere 'a cabeca\n"
			"2 - Insere 'a cauda\n"
			"3 - Remove 'a cabeca\n"
			"4 - Remove 'a cauda\n"
			"5 - Pesquisar\n"
			"6 - Exibir lista\n"
			"0 - Sair\n" );
		scanf( "%d", &menu );
		switch( menu )
			{
			case 1:	printf( "Escolha o valor a inserir: " );
				scanf( "%d", &valor );
				insere_cabeca( &primeiro, valor );
				break;
			case 2:	printf( "Escolha o valor a inserir: " );
				scanf( "%d", &valor );
				insere_cauda( &primeiro, valor );
				break;
			case 3:	remove_cabeca( &primeiro );
				break;
			case 4:	remove_cauda( &primeiro );
				break;
			case 5:	printf( "Escolha o valor a pesquisar: " );
				scanf( "%d", &valor );
				elem = pesquisa( primeiro, valor );
				if( elem == NULL )
					printf( "Valor nao encontrado.\n" );
				else
					printf( "Valor encontrado no endereco %p.\n", elem );
				break;
			case 6:	for( elem = primeiro; elem != NULL; elem = elem->proximo )
					printf( "%d\n", elem->valor );
				break;
			}
		}
		while( menu != 0 );
	return 0;
}
