#include <stdio.h>
#include <stdlib.h>

struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void inserir_cabeca( elemento **p_primeiro, int numero )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = numero;
	p->proximo = *p_primeiro;
	*p_primeiro = p;
}


void inserir_cauda( elemento **p_primeiro, int numero )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = numero;
	p->proximo = NULL;
	if( *p_primeiro == NULL )
		*p_primeiro = p;
	else
		{
		for( ultimo = *p_primeiro;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
}


void remover_cabeca( elemento **p_primeiro )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( *p_primeiro != NULL )
		{
		temp = *p_primeiro;
		*p_primeiro = (*p_primeiro)->proximo;
		free( temp );
		}
}


void remover_cauda( elemento **p_primeiro )
{
	elemento *p;

	/* Elimina a cauda */
	if( *p_primeiro != NULL )
		{
		if( (*p_primeiro)->proximo != NULL )
			{
			for( p = *p_primeiro;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( *p_primeiro );
			*p_primeiro = NULL;
			}
		}
}


elemento *pesquisa( elemento *primeiro, int numero )
{
	elemento *p;

	for( p = primeiro; p != NULL; p = p->proximo )
		{
		if( p->valor == numero )
			break;
		}
	return p;
}


void exibir( elemento *primeiro )
{
	elemento *p;

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );
}


int main( void )
{
	int escolha, numero;
	elemento *resultado;

	do	{
		printf(	"\n"
			"Escolha uma opcao:\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover a cabeca\n"
			"4. Remover a cauda\n"
			"5. Pesquisar\n"
			"6. Exibir a lista\n"
			"0. Sair\n"
			);
		/* while( scanf("%d", &escolha) != 1 ) getchar(); */
		scanf( "%d", &escolha );
		switch( escolha )
			{
			case 1: printf( "Numero a inserir: " );
				scanf( "%d", &numero );
				inserir_cabeca( &primeiro, numero );
				break;
			case 2: printf( "Numero a inserir: " );
				scanf( "%d", &numero );
				inserir_cauda( &primeiro, numero );
				break;
			case 3:	remover_cabeca( &primeiro );
				break;
			case 4:	remover_cauda( &primeiro );
				break;
			case 5: printf( "Numero a pesquisar: " );
				scanf( "%d", &numero );
				resultado = pesquisa( primeiro, numero );
				if( resultado == NULL )
					printf( "Nao encontrei.\n" );
				else
					printf( "Encontrei no endereco %p\n", resultado );
				break;
			case 6:	exibir( primeiro );
				break;
			}
		}
		while( escolha != 0 );

	return 0;
}
