#include <stdio.h>
#include <stdlib.h>

struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


elemento *inserir_cabeca( elemento *prim, int ins_num )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return prim;
	p->valor = ins_num;
	p->proximo = prim;
	return p;
}


elemento *inserir_cauda( elemento *prim, int ins_num )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return prim;
	p->valor = ins_num;
	p->proximo = NULL;
	if( prim == NULL )
		return p;
	else
		{
		for( ultimo = prim;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
	return prim;
}


elemento *remove_cabeca( elemento *prim )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( prim != NULL )
		{
		temp = prim->proximo;
		free( prim );
		return temp;
		}
	return prim;
}


elemento *remove_cauda( elemento *prim )
{
	elemento *p;

	/* Elimina a cauda */
	if( prim != NULL )
		{
		if( prim->proximo != NULL )
			{
			for( p = prim;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( prim );
			return NULL;
			}
		}
	return prim;
}


elemento *pesquisar( elemento *prim, int pes_num )
{
	elemento *p;

	for( p = prim; p != NULL; p = p->proximo )
		{
		if( p->valor == pes_num )
			break;
		}
	return p;
}


int main( void )
{
	int opcao, ins_num, pes_num;
	elemento *encontrado, *ptr;

	do	{
		printf(	"\n"
			"Escolha uma opcao\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover cabeca\n"
			"4. Remover cauda\n"
			"5. Pesquisar\n"
			"6. Exibir a lista\n"
			"0. Sair\n"
			);
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:	printf( "Numero a inserir: " );
				scanf( "%d", &ins_num );
				primeiro = inserir_cabeca( primeiro, ins_num );
				break;
			case 2:	printf( "Numero a inserir: " );
				scanf( "%d", &ins_num );
				primeiro = inserir_cauda( primeiro, ins_num );
				break;
			case 3:	primeiro = remove_cabeca( primeiro );
				break;
			case 4:	primeiro = remove_cauda( primeiro );
				break;
			case 5:	printf( "Numero a pesquisar: " );
				scanf( "%d", &pes_num );
				encontrado = pesquisar( primeiro, pes_num );
				if( encontrado == NULL )
					printf( "Nao encontrado.\n" );
				else
					printf( "Encontrado no endereco %p", encontrado );
				break;
			case 6:	for( ptr = primeiro; ptr != NULL; ptr = ptr->proximo )
					printf( "Valor = %d\n", ptr->valor );
				break;
			}
		}
		while( opcao != 0 );

	return 0;
}
