#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


elemento *insere_cabeca( elemento *cabeca, int valor )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return cabeca;
	p->valor = valor;
	p->proximo = cabeca;
	return p;
}


elemento *insere_cauda( elemento *cabeca, int valor )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return cabeca;
	p->valor = valor;
	p->proximo = NULL;
	if( cabeca == NULL )
		return p;
	else
		{
		for( ultimo = cabeca;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
	return cabeca;
}


elemento *remove_cabeca( elemento *cabeca )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( cabeca != NULL )
		{
		temp = cabeca->proximo;
		free( cabeca );
		return temp;
		}
	return cabeca;
}


elemento *remove_cauda( elemento *cabeca )
{
	elemento *p;

	/* Elimina a cauda */
	if( cabeca != NULL )
		{
		if( cabeca->proximo != NULL )
			{
			for( p = cabeca;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( cabeca );
			return NULL;
			}
		}
	return cabeca;
}


elemento *pesquisa( elemento *cabeca, int valor )
{
	elemento *p;

	for( p = cabeca; p != NULL; p = p->proximo )
		{
		if( p->valor == valor )
			break;
		}
	return p;
}


void exibir( elemento *cabeca )
{
	elemento *p;

	for( p = cabeca;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );
}

				
int main( void )
{
	int opcao, numero;
	elemento *resultado;
	
	do	{
		printf(	"\n"
			"Escolha a opcao\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover a cabeca\n"
			"4. Remover a cauda\n"
			"5. Pesquisar\n"
			"6. Exibir a lista completa\n"
			"0. Sair\n"
			);
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:	printf( "Numero a inserir:" );
				scanf( "%d", &numero );
				primeiro = insere_cabeca( primeiro, numero );
				break;
			case 2:	printf( "Numero a inserir:" );
				scanf( "%d", &numero );
				primeiro = insere_cauda( primeiro, numero );
				break;
			case 3:	primeiro = remove_cabeca( primeiro );
				break;
			case 4:	primeiro = remove_cauda( primeiro );
				break;
			case 5:	printf( "Numero a pesquisar:" );
				scanf( "%d", &numero );
				resultado = pesquisa( primeiro, numero );
				if( resultado == NULL )
					printf( "Nao encontrado\n" );
				else
					printf( "Encontrado no endereco %p\n", resultado );
				break;
			case 6:	exibir( primeiro );
				break;
			}
		}
		while( opcao != 0 );

	return 0;
}
