#include <stdio.h>
#include <stdlib.h>



struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void insere_cabeca( elemento **pp_cabeca, int n )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = n;
	p->proximo = *pp_cabeca;
	*pp_cabeca = p;
}


elemento *insere_cauda( elemento *cabeca, int n )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return cabeca;
	p->valor = n;
	p->proximo = NULL;
	if( cabeca == NULL )
		return p;
	else
		{
		for( ultimo = cabeca;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
	return cabeca;
}


void remove_cabeca( elemento **pp_cabeca )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( *pp_cabeca != NULL )
		{
		temp = *pp_cabeca;
		*pp_cabeca = (*pp_cabeca)->proximo;
		free( temp );
		}
}


elemento *remove_cauda( elemento *cabeca )
{
	elemento *p;

	/* Elimina a cauda */
	if( cabeca != NULL )
		{
		if( cabeca->proximo != NULL )
			{
			for( p = cabeca;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( cabeca );
			return NULL;
			}
		}
	return cabeca;
}


elemento *pesquisa( elemento *cabeca, int n )
{
	elemento *p;

	for( p = cabeca; p != NULL; p = p->proximo )
		{
		if( p->valor == n )
			break;
		}
	return p;
}


void exibir( elemento *cabeca )
{
	elemento *p;

	for( p = cabeca;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );
}

				
int main( void )
{
	int opcao, num;
	elemento *search;
	
	do	{
		printf(	"\n"
			"Escolha a opcao:\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover a cabeca\n"
			"4. Remover a cauda\n"
			"5. Pesquisar elementos\n"
			"6. Exibir lista\n"
			"0. Sair\n"
			);
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:	printf( "Numero a inserir: " );
				scanf( "%d", &num );
				insere_cabeca( &primeiro, num );
				break;
			case 2:	printf( "Numero a inserir: " );
				scanf( "%d", &num );
				primeiro = insere_cauda( primeiro, num );
				break;
			case 3: remove_cabeca( &primeiro );
				break;
			case 4: primeiro = remove_cauda( primeiro );
				break;
			case 5:	printf( "Numero a pesquisar: " );
				scanf( "%d", &num );
				search = pesquisa( primeiro, num );
				if( search == NULL )
					printf( "Nao encontrei\n" );
				else
					printf( "Encontrei no endereco %p", search );
				break;
			case 6: exibir( primeiro );
				break;
			}
		}
		while( opcao != 0 );

	return 0;
}
