
#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void insere_cabeca( void )
{
	int x;
	elemento *p;

	printf( "Escreva o valor a adicionar 'a cabeca da lista: " );
	scanf( "%d", &x );

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = x;
	p->proximo = primeiro;
	primeiro = p;
}


void insere_cauda( void )
{
	int x;
	elemento *p, *ultimo;

	printf( "Escreva o valor a adicionar 'a cauda da lista: " );
	scanf( "%d", &x );

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = x;
	p->proximo = NULL;
	if( primeiro == NULL )
		primeiro = p;
	else
		{
		for( ultimo = primeiro;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
}


void remove_cabeca( void )
{
	elemento *temp;

	if( primeiro != NULL )
		{
		temp = primeiro->proximo;
		free( primeiro );
		primeiro = temp;
		}
}


void remove_cauda( void )
{
	elemento *penultimo;

	if( primeiro != NULL )
		{
		if( primeiro->proximo == NULL )
			{
			free( primeiro );
			primeiro = NULL;
			}
		else
			{
			for( penultimo = primeiro;  penultimo->proximo->proximo != NULL;  penultimo = penultimo->proximo );
			free( penultimo->proximo );
			penultimo->proximo = NULL;
			}
		}
}


void pesquisar( void )
{
	int x, pos, encontrei;
	elemento *p;

	printf( "Escreva o valor a pesquisar na lista: " );
	scanf( "%d", &x );

	encontrei = 0;
	for( pos = 0, p = primeiro;  p != NULL;  pos++, p = p->proximo )
		{
		if( x == p->valor )
			{
			printf( "Encontrei-o no endereco %p e posicao %d\n", p, pos );
			encontrei = 1;
			}
		}
	if( !encontrei )
		printf( "Nao encontrei\n" );
}


void imprimir( void )
{
	elemento *p;

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );
}


void apaga( void )
{
	elemento *p, *temp;

	for( p = primeiro;  p != NULL;  p = temp )
		{
		temp = p->proximo;
		free( p );
		}
	primeiro = NULL;
}


int main()
{
	int opcao;

	for(;;)	{
		printf(	"\n\nSeleccione a opcao"
			"\n1 - Inserir a cabeca"
			"\n2 - Inserir a cauda"
			"\n3 - Remover a cabeca"
			"\n4 - Remover a cauda"
			"\n5 - Pesquisar"
			"\n6 - Imprimir"
			"\n7 - Sair\n" );
		rewind( stdin );
		opcao = getchar();
		switch( opcao )
			{
			case '1':
				insere_cabeca();
				break;
			case '2':
				insere_cauda();
				break;
			case '3':
				remove_cabeca();
				break;
			case '4':
				remove_cauda();
				break;
			case '5':
				pesquisar();
				break;
			case '6':
				imprimir();
				break;
			case '7':
				apaga();
				return 0;
			}
		}
}
