#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX 6

struct no
	{
	int valor;
	struct no *proximo;
	};

typedef struct no NO;

NO *primeiro = NULL;


void exibir()
{
	NO *p;

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );
}


void insere_cabeca()
{
	NO *p;
	int x;

	printf( "Valor a inserir: " );
	scanf( "%d", &x );

	p = malloc( sizeof(NO) );
	if( p == NULL )
		return;
	p->valor = x;

	p->proximo = primeiro;
	primeiro = p;
}


void insere_cauda()
{
	NO *p, *p2;
	int x;

	printf( "Valor a inserir: " );
	scanf( "%d", &x );

	p = malloc( sizeof(NO) );
	if( p == NULL )
		return;
	p->valor = x;

	p->proximo = NULL;
	if( primeiro == NULL )
		primeiro = p;
	else
		{
		for( p2 = primeiro;  p2->proximo != NULL;  p2 = p2->proximo );
		p2->proximo = p;
		}
}


void remove_cabeca()
{
	NO *p;

	if( primeiro == NULL )
		return;
	p = primeiro;
	primeiro = primeiro->proximo;
	free( p );

	printf( "Elemento removido.\n" );
}


void remove_cauda()
{
	NO *p, *p2;

	if( primeiro == NULL )
		return;
	else if( primeiro->proximo == NULL )
		{
		p = primeiro;
		primeiro = NULL;
		free( p );
		}
	else
		{
		for( p2 = primeiro;  p2->proximo->proximo != NULL;  p2 = p2->proximo );
		p = p2->proximo;
		p2->proximo = NULL;
		free( p );
		}

	printf( "Elemento removido.\n" );
}


void pesquisar()
{
	NO *p;
	int x, pos;

	printf( "Valor a pesquisar: " );
	scanf( "%d", &x );

	for( p = primeiro, pos = 0;  p != NULL;  p = p->proximo, pos++ )
		if( x == p->valor )
			printf( "Encontrei na posicao %d\n", pos );
}


int main()
{
	int opcao;

	for(;;)	{
		printf(	"\n\nSeleccione a opcao"
			"\n1 - Inserir cabeca"
			"\n2 - Inserir cauda"
			"\n3 - Remover cabeca"
			"\n4 - Remover cauda"
			"\n5 - Pesquisar"
			"\n6 - Exibir\n" );
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:
				insere_cabeca();
				break;
			case 2:
				insere_cauda();
				break;
			case 3:
				remove_cabeca();
				break;
			case 4:
				remove_cauda();
				break;
			case 5:
				pesquisar();
				break;
			case 6:
				exibir();
				break;
			}
		}
}
