#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX 7

struct jogador
	{
	char nome[100];
	int pontuacao;
	int pocoes;
	int dragoes;
	};

typedef struct jogador JOGADOR;

JOGADOR tabela[MAX] = {
	{ "Dragon Charm",  15907,  4, 6 },
	{ "Gandalf",        8906, 38, 0 },
	{ "Grey Lord",       435,  2, 0 },
	{ "Lady Dragon",    6856, 29, 1 },
	{ "Lady Marion",    6856, 19, 2 },
	{ "Swordmaster",   37002,  0, 0 },
	{ "Zas",            6034, 15, 2 }
	};


int pesquisa_binaria( JOGADOR v[], int tam, char *val )
{
	int lim_inf, lim_sup, i;

	lim_inf = 0;
	lim_sup = tam-1;

	do	{
		i = (lim_inf + lim_sup) / 2;
		if( strcmp(val, v[i].nome) == 0 )
			return i;
		if( strcmp(val, v[i].nome) < 0 )
			lim_sup = i - 1;
		else
			lim_inf = i + 1;
		}
		while( lim_inf <= lim_sup );

	return -1;
}


int main( void )
{
	char val[100];
	int i;

	/* efectua as pesquisas que o utilizador quiser */
	for(;;)	{
		printf( "Nome a pesquisar (* para sair): " );
		scanf( " %99[^\r\n]", val );
		if( strcmp(val, "*") == 0 )
			break;
		i = pesquisa_binaria( tabela, MAX, val );
		if( i < 0 )
			printf( "Esse nome nao foi encontrado.\n" );
		else
			printf( "O nome foi encontrado na posicao %d:\n"
				"\tNome: %s\n"
				"\tPontuacao: %d\n"
				"\tPocoes: %d\n"
				"\tDragoes: %d\n", i,
				tabela[i].nome, tabela[i].pontuacao, tabela[i].pocoes, tabela[i].dragoes );
		}

	return 0;
}
