#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *esq;
	struct s_elemento *dir;
	};

typedef struct s_elemento elemento;


elemento *raiz = NULL;


/* Funcao recursiva para exibir a (sub-)arvore que tem raiz no argumento "no".
   Para exibir essa arvore de forma ordenada, primeiro exibo a sub-arvore
   que esta' 'a esquerda desta, depois este proprio no, e depois a sub-arvore
   que esta' 'a direita.
   A primeira chamada a esta funcao deve ser exibe_arvore(raiz).
*/
void exibe_arvore( elemento *no )
{
	if( no == NULL )
		return;
	exibe_arvore( no->esq );
	printf( " %d ", no->valor );
	exibe_arvore( no->dir );
}


/* Funcao recursiva para apagar toda uma (sub-)arvore que tem raiz no argumento
   "no". O raciocinio e' semelhante ao da funcao exibe_arvore(), acima, mas
   desta vez apago ambas as sub-arvores antes de apagar este no' com um free().
   Nota que a primeira chamada a esta funcao deve ser apaga_arvore(raiz)
   seguido de um raiz=NULL.
*/
void apaga_arvore( elemento *no )
{
	if( no == NULL )
		return;
	apaga_arvore( no->esq );
	apaga_arvore( no->dir );
	free( no );
}


int main()
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return 1;

	p->valor = 8;
	p->esq = NULL;  /* "nao ha' nada 'a esquerda" */
	p->dir = NULL;  /* "nao ha' nada 'a direita"  */
	raiz = p;  /* adiciono este como primeiro e unico elemento da arvore */


	/* Criar agora o segundo elemento e adiciona'-lo ao final da lista
	   ---------------------------------------------------------------
	*/

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return 1;
	p->valor = 9;
	p->esq = p->dir = NULL;

	/*
	Como o adiciono agora? Se fizer
		raiz = p;
	perco o acesso ao elemento que criei 'a bocado. Neste momento a
	variavel "raiz" e' o unico sitio onde esta' o endereco dele
	e se perco esse valor, perco o elemento.

	Preciso de o adicionar "'a direita" do elemento que la' esta'
	(porque p->valor > raiz->valor). Para isso altero o membro
	"dir" do elemento raiz para em vez de dizer "NULL"
	que significa "nao ha' elementos 'a direita a este", para o
	endereco deste novo elemento
	*/
	raiz->dir = p;


	/* "Varrer" a arvore e exibir os valores nela contidos
	   ---------------------------------------------------
	*/

	exibe_arvore( raiz );
	printf( "\n" );


	/* "Varrer" a arvore e libertar a memoria por ela ocupada
	   ------------------------------------------------------
	*/

	apaga_arvore( raiz );
	raiz = NULL;  /* just in case */

	return 0;
}

